import Criterion.Main
import Control.Parallel
import Control.Parallel.Strategies
import System.Random
import Data.Bits
import Control.DeepSeq

-- mergesort implemented by 
-- Jonas Lindgren (main structure) and
-- Niklas kerblom (Adjustments on the parallelism)
-- the sort function sorts with what we have found to be 
-- an optimal granularity factor for our systems.

main = defaultMain[bench "mpsort2" (nf sort randomInts)]

sort :: (NFData a, Ord a)=> [a] -> [a]
sort xs = mpsort (xs,11)

msort :: Ord a => [a] -> [a]
msort [] = []
msort (x:[]) = [x]
msort xs = merge (msort p1) (msort p2)
	where (p1,p2 ) = splitAt ( div (length xs) 2) xs

mpsort :: (NFData a, Ord a )=> Num b => ([a], b)-> [a]
mpsort ([], _) = []
mpsort ((x:[]), _ )= [x]
mpsort (xs, 0) = msort xs
mpsort (xs, n) = par (rnf p2res) (pseq (rnf p1res) (merge p1res p2res))
	where {p2res = mpsort (p2, (n-1)) 
		  ;p1res = mpsort (p1, (n-1))
	      ;(p1,p2 ) = splitAt ( div ((length xs)+1) 2) xs
			}

merge :: Ord a => [a] -> [a] -> [a]
merge [] [] = []
merge [] xs = xs
merge xs [] = xs
merge (x:xs) (y:ys) = case x<y of 
						True -> x:merge xs (y:ys)
						False ->y:merge (x:xs) ys


randomInts = take 200000 (randoms (mkStdGen 211570155)) :: [Integer]
