import System.Random
import Data.List
import Control.Parallel
import Control.Parallel.Strategies
import Criterion.Main

chunkSize = 100
nrRandoms = 200000 

randomInts :: [Integer]
randomInts = take nrRandoms (randoms (mkStdGen 211570155))

isSorted :: [Integer] -> Bool
isSorted (x:[])   = True
isSorted (x:y:xs) = x <= y && isSorted (y:xs)

psort [] = []
psort (x:xs) = par rest $
	psort [y | y <- xs, y < x] 
	++ [x] 
	++ rest
  where rest = psort [y | y <- xs, y >= x]

merge :: [Integer] -> [Integer] -> [Integer]
merge xs [] = xs
merge [] ys = ys
merge (x:xs) (y:ys)
  | x < y  = x : merge xs (y:ys)
  | x >= y = y : merge (x:xs) ys	

prep :: [Integer] -> [[Integer]]
prep = map (flip (:) [])

ssort :: [[Integer]] -> [[Integer]]
ssort []	  = []
ssort (xs:[])     = [xs]
ssort (xs:ys:zss) = pseq ms (ms : (ssort zss)) 
  where
    ms = merge xs ys

untilSort :: [[Integer]] -> [Integer]
untilSort xss  = head $ until 
  (\x -> length x == 1) 
  (\xss' -> ssort xss' `using` parListChunk chunkSize rdeepseq) 
  xss 

psort2 :: [Integer] -> [Integer]
psort2 xs = ((untilSort . prep) xs) 

--main = putStrLn . show $ length $ psort2 randomInts
main = benchmain

benchmain = defaultMain
  [ bench "psort" (nf psort randomInts)
  , bench "psort2" (nf psort2 randomInts)
  ]
