module Tree where

import Data.List (sort)

data Tree a = Empty
            | Node { left  :: Tree a
                   , elem  :: a
                   , right :: Tree a }
  deriving Show

singleton a = Node Empty a Empty

insert a Empty = singleton a
insert a n@(Node l b r)
  | a < b     = n { left  = insert a (left n)  }
  | otherwise = n { right = insert a (right n) }

fromList :: Ord a => [a] -> Tree a
fromList = foldr insert Empty

toList :: Tree a -> [a]
toList t = go t []
  where
    go Empty            []     = []
    go Empty            (x:xs) = go x xs
    go (Node Empty a r) st     = a : go r st
    go (Node l a r)     st     = go l (Node Empty a r : st)

prop_fromTo :: [Integer] -> Bool
prop_fromTo xs = sort xs == toList (fromList xs)
